---
title: Intl.Collator.prototype.compare()
slug: Web/JavaScript/Reference/Global_Objects/Intl/Collator/compare
tags:
  - Collator
  - Internationalization
  - Intl
  - JavaScript
  - Method
  - Prototype
---
<div>{{JSRef}}</div>

<p>The <strong><code>Intl.Collator.prototype.compare()</code></strong> method compares two strings according to the sort order of this {{jsxref("Collator")}} object.</p>

<div>{{EmbedInteractiveExample("pages/js/intl-collator-prototype-compare.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>collator</var>.compare(<var>string1</var>, <var>string2</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>string1</var></code></dt>
 <dt><code><var>string2</var></code></dt>
 <dd>The strings to compare against each other.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The <code>compare</code> getter function returns a number indicating how <code>string1</code> and <code>string2</code> compare to each other according to the sort order of this {{jsxref("Collator")}} object: a negative value if <code>string1</code> comes before <code>string2</code>; a positive value if <code>string1</code> comes after <code>string2</code>; 0 if they are considered equal.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_compare_for_array_sort">Using compare for array sort</h3>

<p>Use the <code>compare</code> getter function for sorting arrays. Note that the function is bound to the collator from which it was obtained, so it can be passed directly to {{jsxref("Array.prototype.sort()")}}.</p>

<pre class="brush: js notranslate">var a = ['Offenbach', 'Österreich', 'Odenwald'];
var collator = new Intl.Collator('de-u-co-phonebk');
a.sort(collator.compare);
console.log(a.join(', '));
// → "Odenwald, Österreich, Offenbach"
</pre>

<h3 id="Using_compare_for_array_search">Using compare for array search</h3>

<p>Use the <code>compare</code> getter function for finding matching strings in arrays:</p>

<pre class="brush: js notranslate">var a = ['Congrès', 'congres', 'Assemblée', 'poisson'];
var collator = new Intl.Collator('fr', { usage: 'search', sensitivity: 'base' });
var s = 'congres';
var matches = a.filter(v =&gt; collator.compare(v, s) === 0);
console.log(matches.join(', '));
// → "Congrès, congres"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ES Int Draft', '#sec-intl.collator.prototype.compare', 'Intl.Collator.prototype.compare')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Intl.Collator.compare")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Collator", "Intl.Collator")}}</li>
 <li>{{jsxref("String.prototype.localeCompare()")}}</li>
</ul>
